/*
    This program is an example of having to map coordinates
    from a square region in the mathematical xy-plane to pixel
    coordinates in a Java graphics window. Try inputting parameters
    200
    2000
    20000
    200000
    which choose successively larger square windows centered at
    the origin in the mathematical xy-plane.

    From "Scientific American", Sept., 1986.
*/
import java.awt.*;
import java.applet.Applet;
import javax.swing.JOptionPane;

public class CircleSquared extends Applet
{
    final int SIZE = 500;

    double xPlane;
    double yPlane;
    double viewingWindowSize;
    double x, y, d;

    public void init ()
    {
       String input = JOptionPane.showInputDialog(
                           "Enter the size of the window in the xy-plane.");
       viewingWindowSize = Integer.parseInt( input );
       xPlane = -viewingWindowSize/2.0;
       yPlane = viewingWindowSize/2.0;

    }//init

    public void paint (Graphics g)
    {
        for (int xPixel = 0; xPixel <= SIZE; xPixel++)
            for (int yPixel = 0; yPixel <= SIZE; yPixel++)
            {
                x = xPlane + (xPixel/(double)SIZE)*viewingWindowSize;
                y = yPlane - (yPixel/(double)SIZE)*viewingWindowSize;
                d = Math.sqrt(Math.pow(x,2) + Math.pow(y,2));
                //d = Math.pow(x,2) + Math.pow(y,2);   //no square root
                if ( ((int)d)%2 == 0  )
                    g.drawLine(xPixel, yPixel, xPixel, yPixel);
            }
    }//paint

}//CircleSquared