/*
    This program is the same as CircleSquared except that the
    square root is removed from the calculation of distance. This
    is the version of the program that gives it its name.
    Try inputting parameters
    100
    200
    300.

    From "Scientific American", Sept., 1986.
*/
import java.awt.*;
import java.applet.Applet;
import javax.swing.JOptionPane;

public class CircleSquared2 extends Applet
{
    final int SIZE = 500;

    double xPlane;
    double yPlane;
    double viewingWindowSize;
    double x, y, d;

    public void init ()
    {
       String input = JOptionPane.showInputDialog(
                           "Enter the size of the window in the xy-plane.");
       viewingWindowSize = Integer.parseInt( input );
       xPlane = -viewingWindowSize/2.0;
       yPlane = viewingWindowSize/2.0;

    }//init

    public void paint (Graphics g)
    {
        for (int xPixel = 0; xPixel <= SIZE; xPixel++)
            for (int yPixel = 0; yPixel <= SIZE; yPixel++)
            {
                x = xPlane + (xPixel/(double)SIZE)*viewingWindowSize;
                y = yPlane - (yPixel/(double)SIZE)*viewingWindowSize;
                d = Math.pow(x,2) + Math.pow(y,2);   //no square root
                if ( ((int)d)%2 == 0  )
                    g.drawLine(xPixel, yPixel, xPixel, yPixel);
            }
    }//paint

}//CircleSquared2