import java.awt.*;
import java.applet.*;

public class Lyapunov extends Applet
{
  double NEGATIVE_THRESHOLD = -.5;
  double POSITIVE_THRESHOLD = 0.1243;
  int horz_pixels = 512;
  int vert_pixels = 512;

  double max = 0;
  double min = 0;

  double a0 = 3.0;  //the a range in parameter space
  double a1 = 3.5;
  double b0 = 3.0;  //the b range in parameter space
  double b1 = 3.5;

  //int patternSize = 12;
  //int loops = 2;
  //int[] pattern = {1,1,1,1,1,1,0,0,0,0,0,0};

  int patternSize = 5;
  int loops = 4;
  int[] pattern = {1,1,0,1,0};

  double a_increment = (a1-a0)/horz_pixels;
  double b_increment = (b1-b0)/vert_pixels;

  double epsilon = .001;

  double a, b, x, y, r, lyapunov;

  public void paint(Graphics g)
  {
    for (int i = 0; i < horz_pixels; i++)
      for (int j = 0; j < vert_pixels; j++)
      {
        a = a0 + i*a_increment; //set the parametrs
        b = b0 + j*b_increment;
        x = 0.4;                //initial value for iteration
        y = x + epsilon;        //perturbed initial value
        for (int n = 1; n <= loops; n++)
          for (int m = 0; m < patternSize; m++)
          {
            if (pattern[m] == 0) r=b; else r=a ;
            x = r*x*(1-x);      //iterate the logistic map
            y = r*y*(1-y);
          }
        lyapunov = Math.log(Math.abs(y-x)/epsilon)/(loops*patternSize);
        // find the maximum and minimum Lyapunov exponents
        if (lyapunov > max) max = lyapunov;
        if (lyapunov < min) min = lyapunov;

        // choose a color for the data point
        int colorNumber;
        if (lyapunov >= 0)
          colorNumber = (int)( (lyapunov/POSITIVE_THRESHOLD)*16777215 );
          //colorNumber = (int)( (lyapunov/POSITIVE_THRESHOLD)*65535 );
        else
          colorNumber = (int)( (lyapunov/NEGATIVE_THRESHOLD)*-65535 );
          //colorNumber = (int)( (lyapunov/NEGATIVE_THRESHOLD)*-16777215 );
        g.setColor( new Color(colorNumber) );

        // plot the data point
        g.drawLine(i, j, i, j);
      }
    // print the maximum and minimum Lyapunov exponent values
    System.out.println("max = " + max + " and min = " + min );
  }//paint

}//Lyapunov