/*
    Simulate a random walk. The random walk ends when
    an edge of the window is met. Notice how we use a
    while loop since we do not know how many steps it
    will take to get to an edge.
*/
import java.applet.Applet;
import java.awt.*;

public class RandomWalk extends Applet
{
   public void paint(Graphics g)
   {
     // set the size of the graphics window
     int SIZE = 500;
     setSize(SIZE, SIZE);

     //set the coordinates of the starting point
     int x = 250;
     int y =250;

     int steps = 0; //count the number of steps

     // loop until the random walker hits the edge of the window
     while ( x > 0 && x < SIZE && y > 0 && y < SIZE )
     {
        int direction = (int) (4*Math.random());
        // compute a random step
        if (direction == 0)
           x = x + 1;
        else if (direction == 1)
           x = x - 1;
        else if (direction == 2)
           y = y + 1;
        else if (direction == 3)
           y = y -1;
        // plot the new position
        g.drawLine(x,y,x,y);
        steps++;
     }
     // Display the number of steps taken.
     g.setColor( Color.red );
     g.drawString("Done in " + steps + " steps.", 200, 15);
     System.out.println("Done in " + steps + " steps.");
   }//paint
}//RandomWalk