/*
    This version of the random walk allows the
    size of the step to be changed. This version
    also allows the random walk to be slowed down
    so that it can be watched better.
*/
import java.applet.Applet;
import java.awt.*;

public class RandomWalk2 extends Applet
{
   public void paint(Graphics g)
   {
     // set the size of the graphics window
     int SIZE = 500;
     setSize(SIZE, SIZE);

     // set the size of each step
     int stepSIZE = 5;

     //set the coordinates of the starting point
     int x = 250;
     int y =250;
     int xNew = 250;
     int yNew = 250;

     int steps = 0; //count the number of steps

     // loop until the random walker hits the edge of the window
     while ( x > 0 && x < SIZE && y > 0 && y < SIZE )
     {
        int direction = (int) (4*Math.random());
        // compute a random step
        if (direction == 0)
           xNew = x + stepSIZE;
        else if (direction == 1)
           xNew = x - stepSIZE;
        else if (direction == 2)
           yNew = y + stepSIZE;
        else if (direction == 3)
           yNew = y -stepSIZE;
        // draw the step
        g.drawLine(x,y,xNew,yNew);
        // remember the new position
        if (x != xNew) x = xNew;
        if (y != yNew) y = yNew;
        steps++;
        // pause for a number of milliseconds
        try{Thread.currentThread().sleep(5);}catch(Exception e){}
     }
     // Display the number of steps taken.
     g.setColor( Color.red );
     g.drawString("Done in " + steps + " steps.", 200, 15);
     System.out.println("Done in " + steps + " steps.");
   }//paint
}//RandomWalk2