/*
    This version of the random walk has eight directions
    that the walker can choose from.
*/
import java.applet.Applet;
import java.awt.*;

public class RandomWalk3 extends Applet
{
   public void paint(Graphics g)
   {
     // set the size of the graphics window
     int SIZE = 500;
     setSize(SIZE, SIZE);

     // set the size of each step
     int stepSIZE = 7;

     //set the coordinates of the starting point
     int x = 250;
     int y =250;
     int xNew = 250;
     int yNew = 250;

     int steps = 0; //count the number of steps

     // loop until the random walker hits the edge of the window
     while ( x > 0 && x < SIZE && y > 0 && y < SIZE )
     {
        int direction = (int) (8*Math.random());
        // compute a random step
        if (direction == 0)
            xNew = x + stepSIZE;  //step east
        else if (direction == 1)
        {   xNew = x + stepSIZE;  //step southeast
            yNew = y + stepSIZE;
        }
        else if (direction == 2)
            yNew = y + stepSIZE;  //step south
        else if (direction == 3)
        {   xNew = x - stepSIZE;  //step southwest
            yNew = y + stepSIZE;
        }
        else if (direction == 4)
            xNew = x - stepSIZE;  //step west
        else if (direction == 5)
        {   xNew = x - stepSIZE;  //step northwest
            yNew = y - stepSIZE;
        }
        else if (direction == 6)
            yNew = y - stepSIZE;  //step north
        else if (direction == 7)
        {   xNew = x + stepSIZE;  //step northeast
            yNew = y - stepSIZE;
        }
        // draw the step
        g.drawLine(x,y,xNew,yNew);
        // remember the new position
        if (x != xNew) x = xNew;
        if (y != yNew) y = yNew;
        steps++;
        // pause for a number of milliseconds
        try{Thread.currentThread().sleep(5);}catch(Exception e){}
     }
     // Display the number of steps taken.
     g.setColor( Color.red );
     g.drawString("Done in " + steps + " steps.", 200, 15);
     System.out.println("Done in " + steps + " steps.");
   }//paint
}//RandomWalk3